# Commerce Shipping Product Exclude

Adds a commerce product / variation field type and a commerce condition, which serve to exclude specific shipping methods not allowed for a product / variation.

For a full description of the module, visit the
[project page](https://www.drupal.org/project/commerce_shipping_product_exclude).

Submit bug reports and feature suggestions, or track changes in the
[issue queue](https://www.drupal.org/project/issues/commerce_shipping_product_exclude).

## Requirements (required)

This module requires the following modules:

- [Commerce](https://www.drupal.org/project/commerce)
- [Commerce Shipping](https://www.drupal.org/project/commerce_shipping)

## Installation

Install as you would normally install a contributed Drupal module. For further information, see [Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).


## Configuration

- Enable the module at Administration > Extend.
- Now create a new "Exclude Shipping Method" field on a product and / or product variation and make sure to set the cardinality to "Unlimited".
- For every "Shipping Method" you desire to be excluded on a product / product variation level, you need to enable the "Allow to exclude From Shipping" condition on the excludable shipping method.
- Now, when all desired shipping methods are tagged for potential exclusion, you can define for each product / product variation instance, which shipping method you don't want to allow for that specific product / product variation instance.
  - Note, that the condition will always check, on the product variation level, whether the "Allow to exclude From Shipping" field is set and whether its value is empty. If the field is not set or the field value is empty, it will do the same check on the parent product. Meaning if the field is set on both the product and product variation, the value of the product variation will overwrite the field value of the product.
- Done!
